searchData={"items":[{"type":"module","title":"PexelsEx","doc":"Written by B.j Mayor  \n`PexelsEx` is an Elixir SDK for interacting with the Pexels API.\n\nThis module provides functions to search and retrieve photos, videos, and collections from Pexels.","ref":"PexelsEx.html"},{"type":"function","title":"PexelsEx.curated_photos/1","doc":"Retrieves curated photos.","ref":"PexelsEx.html#curated_photos/1"},{"type":"function","title":"Parameters - PexelsEx.curated_photos/1","doc":"- `options`: Optional parameters for the API request.","ref":"PexelsEx.html#curated_photos/1-parameters"},{"type":"function","title":"Returns - PexelsEx.curated_photos/1","doc":"- `{:ok, photos}` on success.\n- `{:error, reason}` on failure.","ref":"PexelsEx.html#curated_photos/1-returns"},{"type":"function","title":"PexelsEx.featured_collections/1","doc":"Retrieves featured collections.","ref":"PexelsEx.html#featured_collections/1"},{"type":"function","title":"Parameters - PexelsEx.featured_collections/1","doc":"- `options`: Optional parameters for the API request.","ref":"PexelsEx.html#featured_collections/1-parameters"},{"type":"function","title":"Returns - PexelsEx.featured_collections/1","doc":"- `{:ok, collections}` on success.\n- `{:error, reason}` on failure.","ref":"PexelsEx.html#featured_collections/1-returns"},{"type":"function","title":"PexelsEx.popular_videos/1","doc":"Retrieves popular videos.","ref":"PexelsEx.html#popular_videos/1"},{"type":"function","title":"Parameters - PexelsEx.popular_videos/1","doc":"- `options`: Optional parameters for the API request.","ref":"PexelsEx.html#popular_videos/1-parameters"},{"type":"function","title":"Returns - PexelsEx.popular_videos/1","doc":"- `{:ok, videos}` on success.\n- `{:error, reason}` on failure.","ref":"PexelsEx.html#popular_videos/1-returns"},{"type":"function","title":"PexelsEx.search_photos/2","doc":"Searches for photos based on a query string.","ref":"PexelsEx.html#search_photos/2"},{"type":"function","title":"Parameters - PexelsEx.search_photos/2","doc":"- `query`: The search term for photos.\n- `options`: Optional parameters for the API request.","ref":"PexelsEx.html#search_photos/2-parameters"},{"type":"function","title":"Returns - PexelsEx.search_photos/2","doc":"- `{:ok, photos}` on success.\n- `{:error, reason}` on failure.","ref":"PexelsEx.html#search_photos/2-returns"},{"type":"function","title":"PexelsEx.search_videos/2","doc":"Searches for videos based on a query string.","ref":"PexelsEx.html#search_videos/2"},{"type":"function","title":"Parameters - PexelsEx.search_videos/2","doc":"- `query`: The search term for videos.\n- `options`: Optional parameters for the API request.","ref":"PexelsEx.html#search_videos/2-parameters"},{"type":"function","title":"Returns - PexelsEx.search_videos/2","doc":"- `{:ok, videos}` on success.\n- `{:error, reason}` on failure.","ref":"PexelsEx.html#search_videos/2-returns"},{"type":"module","title":"PexelsEx.Client","doc":"A client for interacting with the Pexels API.\n\nThis module provides functions to make HTTP requests to the Pexels API,\nincluding processing URLs, request headers, and response bodies.","ref":"PexelsEx.Client.html"},{"type":"function","title":"PexelsEx.Client.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#delete/3"},{"type":"function","title":"PexelsEx.Client.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#delete!/3"},{"type":"function","title":"PexelsEx.Client.get/2","doc":"Makes a GET request to the given URL with optional query parameters.\n\nOnly the parameters specified in `@valid_params` are included in the query string.","ref":"PexelsEx.Client.html#get/2"},{"type":"function","title":"Parameters - PexelsEx.Client.get/2","doc":"- `url`: The endpoint URL (string).\n  - `params`: A keyword list of query parameters (optional).","ref":"PexelsEx.Client.html#get/2-parameters"},{"type":"function","title":"Examples - PexelsEx.Client.get/2","doc":"iex> PexelsEx.Client.get(\"/v1/search\", query: \"nature\", per_page: 10)\n    {:ok, %{\"photos\" => [...]}}","ref":"PexelsEx.Client.html#get/2-examples"},{"type":"function","title":"PexelsEx.Client.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#get/3"},{"type":"function","title":"PexelsEx.Client.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#get!/3"},{"type":"function","title":"PexelsEx.Client.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#head/3"},{"type":"function","title":"PexelsEx.Client.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#head!/3"},{"type":"function","title":"PexelsEx.Client.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#options/3"},{"type":"function","title":"PexelsEx.Client.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#options!/3"},{"type":"function","title":"PexelsEx.Client.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#patch/4"},{"type":"function","title":"PexelsEx.Client.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#patch!/4"},{"type":"function","title":"PexelsEx.Client.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#post/4"},{"type":"function","title":"PexelsEx.Client.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#post!/4"},{"type":"function","title":"PexelsEx.Client.process_headers/1","doc":"","ref":"PexelsEx.Client.html#process_headers/1"},{"type":"function","title":"PexelsEx.Client.process_request_body/1","doc":"","ref":"PexelsEx.Client.html#process_request_body/1"},{"type":"function","title":"PexelsEx.Client.process_request_headers/1","doc":"Processes the request headers by adding the Authorization header with the API key.\n\nThe API key is fetched from the environment variable `PEXELS_API_KEY` or from the application configuration.","ref":"PexelsEx.Client.html#process_request_headers/1"},{"type":"function","title":"Examples - PexelsEx.Client.process_request_headers/1","doc":"iex> PexelsEx.Client.process_request_headers([])\n    [{\"Authorization\", \"your_api_key\"}]","ref":"PexelsEx.Client.html#process_request_headers/1-examples"},{"type":"function","title":"PexelsEx.Client.process_request_options/1","doc":"","ref":"PexelsEx.Client.html#process_request_options/1"},{"type":"function","title":"PexelsEx.Client.process_request_params/1","doc":"","ref":"PexelsEx.Client.html#process_request_params/1"},{"type":"function","title":"PexelsEx.Client.process_request_url/1","doc":"","ref":"PexelsEx.Client.html#process_request_url/1"},{"type":"function","title":"PexelsEx.Client.process_response/1","doc":"","ref":"PexelsEx.Client.html#process_response/1"},{"type":"function","title":"PexelsEx.Client.process_response_body/1","doc":"Processes the response body by decoding it from JSON.","ref":"PexelsEx.Client.html#process_response_body/1"},{"type":"function","title":"Examples - PexelsEx.Client.process_response_body/1","doc":"iex> PexelsEx.Client.process_response_body(\"{\"key\": \"value\"}\")\n    %{\"key\" => \"value\"}","ref":"PexelsEx.Client.html#process_response_body/1-examples"},{"type":"function","title":"PexelsEx.Client.process_response_chunk/1","doc":"","ref":"PexelsEx.Client.html#process_response_chunk/1"},{"type":"function","title":"PexelsEx.Client.process_response_headers/1","doc":"","ref":"PexelsEx.Client.html#process_response_headers/1"},{"type":"function","title":"PexelsEx.Client.process_response_status_code/1","doc":"","ref":"PexelsEx.Client.html#process_response_status_code/1"},{"type":"function","title":"PexelsEx.Client.process_status_code/1","doc":"","ref":"PexelsEx.Client.html#process_status_code/1"},{"type":"function","title":"PexelsEx.Client.process_url/1","doc":"Processes the given URL by appending it to the base URL.","ref":"PexelsEx.Client.html#process_url/1"},{"type":"function","title":"Examples - PexelsEx.Client.process_url/1","doc":"iex> PexelsEx.Client.process_url(\"/v1/search\")\n    \"https://api.pexels.com/v1/search\"","ref":"PexelsEx.Client.html#process_url/1-examples"},{"type":"function","title":"PexelsEx.Client.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"PexelsEx.Client.html#put/4"},{"type":"function","title":"PexelsEx.Client.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#put!/4"},{"type":"function","title":"PexelsEx.Client.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"PexelsEx.Client.html#request/1"},{"type":"function","title":"Redirect handling - PexelsEx.Client.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"PexelsEx.Client.html#request/1-redirect-handling"},{"type":"function","title":"Examples - PexelsEx.Client.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"PexelsEx.Client.html#request/1-examples"},{"type":"function","title":"PexelsEx.Client.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"PexelsEx.Client.html#request/5"},{"type":"function","title":"Redirect handling - PexelsEx.Client.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"PexelsEx.Client.html#request/5-redirect-handling"},{"type":"function","title":"Examples - PexelsEx.Client.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"PexelsEx.Client.html#request/5-examples"},{"type":"function","title":"PexelsEx.Client.request!/1","doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"PexelsEx.Client.html#request!/1"},{"type":"function","title":"PexelsEx.Client.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"PexelsEx.Client.html#request!/5"},{"type":"function","title":"PexelsEx.Client.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"PexelsEx.Client.html#start/0"},{"type":"function","title":"PexelsEx.Client.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"PexelsEx.Client.html#stream_next/1"},{"type":"type","title":"PexelsEx.Client.body/0","doc":"","ref":"PexelsEx.Client.html#t:body/0"},{"type":"type","title":"PexelsEx.Client.headers/0","doc":"","ref":"PexelsEx.Client.html#t:headers/0"},{"type":"type","title":"PexelsEx.Client.method/0","doc":"","ref":"PexelsEx.Client.html#t:method/0"},{"type":"type","title":"PexelsEx.Client.options/0","doc":"","ref":"PexelsEx.Client.html#t:options/0"},{"type":"type","title":"PexelsEx.Client.params/0","doc":"","ref":"PexelsEx.Client.html#t:params/0"},{"type":"type","title":"PexelsEx.Client.request/0","doc":"","ref":"PexelsEx.Client.html#t:request/0"},{"type":"type","title":"PexelsEx.Client.url/0","doc":"","ref":"PexelsEx.Client.html#t:url/0"},{"type":"module","title":"PexelsEx.Collection","doc":"Struct and parsing functions for Pexels collections.","ref":"PexelsEx.Collection.html"},{"type":"function","title":"PexelsEx.Collection.parse/1","doc":"","ref":"PexelsEx.Collection.html#parse/1"},{"type":"function","title":"PexelsEx.Collection.parse_many/1","doc":"","ref":"PexelsEx.Collection.html#parse_many/1"},{"type":"module","title":"PexelsEx.Photo","doc":"This module defines a struct and functions for parsing photo data from the Pexels API.","ref":"PexelsEx.Photo.html"},{"type":"module","title":"Struct Fields - PexelsEx.Photo","doc":"- `:id` - The unique identifier for the photo.\n  - `:width` - The width of the photo in pixels.\n  - `:height` - The height of the photo in pixels.\n  - `:url` - The URL to the photo's page on Pexels.\n  - `:photographer` - The name of the photographer.\n  - `:photographer_url` - The URL to the photographer's profile on Pexels.\n  - `:src` - A map containing URLs to different sizes of the photo.","ref":"PexelsEx.Photo.html#module-struct-fields"},{"type":"module","title":"Example - PexelsEx.Photo","doc":"iex> photo = %PexelsEx.Photo{\n    ...>   id: 12345,\n    ...>   width: 1920,\n    ...>   height: 1080,\n    ...>   url: \"https://www.pexels.com/photo/12345\",\n    ...>   photographer: \"John Doe\",\n    ...>   photographer_url: \"https://www.pexels.com/@johndoe\",\n    ...>   photographer_id: 67890,\n    ...>   avg_color: \"#AABBCC\",\n    ...>   src: %{\"original\" => \"https://images.pexels.com/photos/12345/original.jpg\"},\n    ...>   liked: true,\n    ...>   alt: \"A beautiful scenery\"\n    ...> }","ref":"PexelsEx.Photo.html#module-example"},{"type":"function","title":"PexelsEx.Photo.parse/1","doc":"Parses a single photo map into a `%PexelsEx.Photo{}` struct.","ref":"PexelsEx.Photo.html#parse/1"},{"type":"function","title":"Parameters - PexelsEx.Photo.parse/1","doc":"- `photo` - A map representing a photo, typically from the Pexels API response.","ref":"PexelsEx.Photo.html#parse/1-parameters"},{"type":"function","title":"Returns - PexelsEx.Photo.parse/1","doc":"- A `%PexelsEx.Photo{}` struct populated with the data from the input map.","ref":"PexelsEx.Photo.html#parse/1-returns"},{"type":"function","title":"Example - PexelsEx.Photo.parse/1","doc":"iex> photo_map = %{\n    ...>   \"id\" => 12345,\n    ...>   \"width\" => 1920,\n    ...>   \"height\" => 1080,\n    ...>   \"url\" => \"https://www.pexels.com/photo/12345\",\n    ...>   \"photographer\" => \"John Doe\",\n    ...>   \"photographer_url\" => \"https://www.pexels.com/@johndoe\",\n    ...>   \"photographer_id\" => 67890,\n    ...>   \"avg_color\" => \"#AABBCC\",\n    ...>   \"src\" => %{\"original\" => \"https://images.pexels.com/photos/12345/original.jpg\"},\n    ...>   \"liked\" => true,\n    ...>   \"alt\" => \"A beautiful scenery\"\n    ...> }\n    iex> PexelsEx.Photo.parse(photo_map)\n    %PexelsEx.Photo{\n      id: 12345,\n      width: 1920,\n      height: 1080,\n      url: \"https://www.pexels.com/photo/12345\",\n      photographer: \"John Doe\",\n      photographer_url: \"https://www.pexels.com/@johndoe\",\n      photographer_id: 67890,\n      avg_color: \"#AABBCC\",\n      src: %{\"original\" => \"https://images.pexels.com/photos/12345/original.jpg\"},\n      liked: true,\n      alt: \"A beautiful scenery\"\n    }","ref":"PexelsEx.Photo.html#parse/1-example"},{"type":"function","title":"PexelsEx.Photo.parse_many/1","doc":"Parses a response map containing multiple photos into a map with metadata and a list of `%PexelsEx.Photo{}` structs.","ref":"PexelsEx.Photo.html#parse_many/1"},{"type":"function","title":"Parameters - PexelsEx.Photo.parse_many/1","doc":"- `response` - A map representing the response from the Pexels API, containing multiple photos and metadata.","ref":"PexelsEx.Photo.html#parse_many/1-parameters"},{"type":"function","title":"Returns - PexelsEx.Photo.parse_many/1","doc":"- A map with the following keys:\n    - `:total_results` - The total number of results available.\n    - `:page` - The current page number.\n    - `:per_page` - The number of results per page.\n    - `:photos` - A list of `%PexelsEx.Photo{}` structs parsed from the response.","ref":"PexelsEx.Photo.html#parse_many/1-returns"},{"type":"function","title":"Example - PexelsEx.Photo.parse_many/1","doc":"iex> response_map = %{\n    ...>   \"total_result\" => 100,\n    ...>   \"page\" => 1,\n    ...>   \"","ref":"PexelsEx.Photo.html#parse_many/1-example"},{"type":"module","title":"PexelsEx.Video","doc":"","ref":"PexelsEx.Video.html"},{"type":"function","title":"PexelsEx.Video.parse/1","doc":"","ref":"PexelsEx.Video.html#parse/1"},{"type":"function","title":"PexelsEx.Video.parse_many/1","doc":"","ref":"PexelsEx.Video.html#parse_many/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}